$(document).ready(function () {

    var table = $('#myTable').DataTable({
        "scrollX": true,
        "order": [],
        "columns": [
            { "data": "reference_no" },
            { "data": "supplier" },
            { "data": "date" },
            { "data": "edit", className: "edit" },
            { "data": "view", className: "view" },
            { "data": "print", className: "print" },
            { "data": "approve", className: "approve" },
            { "data": "delete", className: "delete" },
        ],
        columnDefs: [
            { width: 200, targets: 0 },
            { width: 200, targets: 2 },
            { width: 30, targets: 3 },
            { width: 30, targets: 4 },
            { width: 30, targets: 5 },
            { width: 30, targets: 6 },
        ],
    });
    table.column(7).visible(false);

    allGrn();

});


function allGrn() {
    $.ajax({
        type: "GET",
        url: "/sc/grnListController/allGrn",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            if (response.data.success) {
                var data = [];

                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['internal_id'];
                    var reference_no = response.data.result[i]['external_id'];
                    var name = response.data.result[i]['supplier'];
                    var designation = response.data.result[i]['trans_date'];
                    var status = response.data.result[i]['status'];
                    var string_id = "'" + id + "'";

                    var approve_btn = '<i class="fa fa-times" aria-hidden="true"></i>';
                    var disabled = "";
                    if (status == 1) {
                        approve_btn = '<i class="fa fa-check" aria-hidden="true"></i>';
                        disabled = "disabled";
                    }

                    data.push({
                        "reference_no": reference_no,
                        "supplier": name,
                        "date": designation,
                        "edit": '<button class="btn btn-primary" onclick="edit(' + string_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        "view": '<button class="btn btn-success" onclick="view(' + string_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        "print": '<button class="btn btn-success" onclick="print(' + string_id + ')"><i class="fa fa-print" aria-hidden="true"></i></button>',
                        "approve": '<button id="approve' + id + '" class="btn btn-success" onclick="approve_confirmation(' + string_id + ')" ' + disabled + '>' + approve_btn + '</button>',
                        "delete": '<button class="btn btn-danger" onclick="_delete(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>'
                    });
                }

                var table = $('#myTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        },

        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}


function edit(id) {
    location.href = "/sc/grn?id=" + id + "&action=edit";
}



function view(id) {
    location.href = "/sc/grn?id=" + id + "&action=view";
}



function approve_confirmation(id) {
    swal({
        title: "Are you sure want to approve?",
        //text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: {
            yes: {
                text: "Yes",
                value: true,
                className: 'btn btn-danger',
            },
            no: {
                text: "No",
                value: false,
                className: 'btn btn-primary',
            }
        },

    })
        .then((willDelete) => {
            if (willDelete) {
                approve(id);
            }
        });

}


function approve(id) {
    $.ajax({
        type: "PUT",
        url: '/sc/grnHeaderController/approve/' + id,
        data: {
            status: 1,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            document.getElementById('approve' + id).innerHTML = '<i class="fa fa-circle-o-notch fa-spin"></i>';
        },
        success: function (response) {
            console.log(response);
            toastr.success(response.data.result.message);
            $('#approve' + id).html(response.data.result.icon);
            allGrn();
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
            // document.getElementById('approve'+id).innerHTML = '<i class="fa fa-times" aria-hidden="true"></i>';
        }

    });
}



function print(id) {

    $.ajax({
        type: "GET",
        url: "/sc/grnListController/goodsReceivedReport/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            //$('.btn').prop("disabled", true);
            //document.getElementById('btnPrint').innerHTML = '<i class="fa fa-circle-o-notch fa-spin"></i>';
        },
        success: function (response) {
            console.log(response);
            var result = response.data.result;
            console.log(result);
            goodsReceivedPrint(result, 'PRINT');

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            //$('#btnPrint').text('Print');
            //$('.btn').prop("disabled", false);
        }

    });

}


function goodsReceivedPrint(result, flag) {

    var headerFontSize = 8;
    var Title = [
        { text: '' }
    ];

    var header_data = result.header;


    var Header = [
        {
            content: [

                {
                    table: {
                        widths: ['*'],
                        headerRows: 1,
                        body: [
                            [{ text: Page.getReportName(), fontSize: 16, bold: true, alignment: 'center', border: [false, false, false, false] }],
                            //[{ text: '\n', fontSize: 8, bold: true, alignment: 'center', border: [false, false, false, false] }],
                            [{ text: 'Goods Received', fontSize: 14, bold: true, alignment: 'center', border: [false, false, false, false] }],
                            [{
                                table: {
                                    widths: ['*', 150],
                                    headerRows: 1,
                                    body: [
                                        [{ text: 'Supplier : ' + header_data.supplier, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Referance No : ' + header_data.referance_no, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: 'Received By : ' + header_data.received_by, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Date : ' + header_data.date, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: '', fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Store : ' + header_data.store, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: '', fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Supplier Ref No : ' + header_data.supplier_ref_no, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: '', fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'PO No. : ' + header_data.po_no, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: '', fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Transport By : ' + header_data.transport_by, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],
                                        [{ text: '', fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }, { text: 'Vehicle No : ' + header_data.vehicle_no, fontSize: 9, bold: false, alignment: 'left', border: [false, false, false, false] }],


                                    ],

                                }, border: [false, false, false, false]
                            }],
                        ],

                    },
                    margin: [0, 0],
                },

            ]
        }
    ];



    var footer_data = result.header;
    var Body = [
        {
            table: {
                widths: [50, '*', 50, 50, '*'],
                headerRows: 1,
                body: goodsReceivedPrintBody(result.body),
                //body:[{text:""},{text:""},{text:""},{text:""}],

            },
        },
        {
            table: {
                widths: ['*', 60],
                headerRows: 0,

                body: [
                    [
                        { text: 'Total No of Items :', fontSize: 9, bold: false, alignment: 'right', border: [false, true, false, true] ,margin: [ 0, 0, 0, 0], colSpan: 1 },
                        { text: parseFloat(result.header.no_of_items).toFixed(2), fontSize: 9, bold: false, alignment: 'center', border: [false, true, false, true] ,margin: [ 0, 0, 0, 0] },

                    ],


                ],
            },
        },
        //{ canvas: [{ type: 'line', x1: 0, y1: 0, x2: 515, y2: 0, lineWidth: 1 }] },
        { text: '', margin: [ 5, 2, 10, 20 ] },
        {
            table: {
                widths: [100, 100,100, 100, '*'],
                headerRows: 1,

                body: [
                    [
                        { text: 'Prepared By', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false],margin: [ 0, 0, 0, 15] },
                        { text: 'Checked By', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] ,margin: [ 0, 0, 0, 15] },
                        { text: 'Received By', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] ,margin: [ 0, 0, 0, 15] },
                        { text: '', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] ,margin: [ 0, 0, 0, 15] },
                        { text: 'Authorized By', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] ,margin: [ 0, 0, 0, 15] },
                    ],
                    [
                        { text: '..................................', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] },
                        { text: '..................................', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] },
                        { text: '..................................', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] },
                        { text: '', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] },
                        { text: '..................................', fontSize: 9, bold: false, alignment: 'center', border: [false, false, false, false] },
                    ],


                ],
            },


        },

    ];




    var Footer = [

        {
            color: 'red',
            fontSize: 8,
            alignment: 'center',
            margin: [0, 0]
        }
    ];






    var page = new Page();
    page.setPageSize('A4');
    page.setPageOrientation('portrait');
    page.setPageMargin([10, 10, 10, 10]);
    page.setTitle(Title);
    page.setHeader(Header, Page.EVERY);
    page.setBody(Body);
    page.setFooter(Footer);
    if (flag == 'EXPORT') {
        page.export();
    } else if (flag == 'PRINT') {
        page.preview();
    }
}


function goodsReceivedPrintBody(result) {
    var font_size = 8;
    var body = [];
    body.push([{ text: 'Product ID', fontSize: font_size, bold: true, alignment: 'center', border: [true, true, true, true] },
    { text: 'Product Name', fontSize: font_size, bold: true, alignment: 'center', border: [true, true, true, true] },
    { text: 'Unit', fontSize: font_size, bold: true, alignment: 'center', border: [true, true, true, true] },
    { text: 'Qty', fontSize: font_size, bold: true, alignment: 'right', border: [true, true, true, true] },
    { text: 'Comments', fontSize: font_size, bold: true, alignment: 'center', border: [true, true, true, true] }]);

    var data = result.data;
    for (i = 0; i < data.length; i++) {
        body.push([
            { text: data[i].product_id, fontSize: font_size, alignment: 'center', border: [true, false, false, false] },
            { text: data[i].product, fontSize: font_size, alignment: 'center', border: [false, false, false, false] },
            { text: data[i].unit, fontSize: font_size, alignment: 'center', border: [false, false, false, false] },
            { text: parseFloat(data[i].quantity).toFixed(2), fontSize: font_size, alignment: 'right', border: [false, false, false, false] },
            { text: data[i].comments, fontSize: font_size, alignment: 'center', border: [false, false, true, false] },
        ]);
    }

    return body;
}